#include <windows.h>
#include <stdio.h>
#include <io.h>
#include <stdlib.h>
#include <fcntl.h>
#include "vicdefs.h"


int CopyScreenToImage(imgdes *image)
{
  HDC hScrDC;           // screen DC
  HBITMAP hBitmap;      // handles to device-dependent bitmaps
  int rcode = BAD_BMP;
  int xScrn, yScrn;
   

  // create a DC for the screen
  hScrDC = CreateDC("DISPLAY", NULL, NULL, NULL);
  if (!hScrDC) return rcode;

  // get screen resolution
  xScrn = GetDeviceCaps(hScrDC, HORZRES);
  yScrn = GetDeviceCaps(hScrDC, VERTRES);

  // get the bitmap of the screen
  hBitmap = GetCurrentObject(hScrDC, OBJ_BITMAP);
  if (!hBitmap) return rcode;

  // Allocate space for the Victor image
  rcode = allocimage(image, xScrn, yScrn, 24);
  if (rcode == NO_ERROR)
  {
    // Transfer bitmap bits to DIB
    if (GetDIBits(hScrDC, hBitmap, 0, (unsigned)image->bmh->biHeight,
      (LPSTR)image->ibuff, (BITMAPINFO far *)image->bmh,
      DIB_RGB_COLORS) == 0)
      rcode = BAD_BMP; // GetDIBits() failed
  }
   
  // clean up
  DeleteDC(hScrDC);

  return rcode;
}



void main(void)
{
  imgdes img;
  char tempfilename[200];
  FILE *fp;
  HDESK hdesk;

  setbuf(stdout, NULL);
  setmode(fileno(stdout), O_BINARY);

/*
  hdesk = GetThreadDesktop( GetCurrentThreadId());
  hdesk = OpenInputDesktop(0, FALSE, READ_CONTROL);
  SetThreadDesktop(hdesk);
*/

  tmpnam(tempfilename);
  CopyScreenToImage(&img);
  savejpg(tempfilename, &img, 75);

  fp = fopen(tempfilename, "rb");
  if (fp)
  {
    long length;
    char *buffer;

    fseek(fp, 0, SEEK_END);
    length = ftell(fp);
    fseek(fp, 0, SEEK_SET);
    printf("Content-type: image/jpeg\n"
           "Content-length: %lu\n\n", length);
    buffer = new char[length];
    fread(buffer, 1, length, fp);
    fwrite(buffer, 1, length, stdout);
    delete buffer;
    fclose(fp);    
  }
  unlink(tempfilename);
}


